<link href="<?php echo base_url('assets/plugins/custombox/css/custombox.css'); ?>" rel="stylesheet">
<script src="<?php echo base_url('assets/plugins/custombox/js/custombox.min.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/custombox/js/legacy.min.js'); ?>"></script>

<style>
.busy {
  border: 16px solid #f3f3f3;
  border-radius: 50%;
  border-top: 16px solid blue;
  border-bottom: 16px solid blue;
  width: 120px;
  height: 120px;
  -webkit-animation: spin 2s linear infinite;
  animation: spin 2s linear infinite;
}

@-webkit-keyframes spin {
  0% { -webkit-transform: rotate(0deg); }
  100% { -webkit-transform: rotate(360deg); }
}

@keyframes spin {
  0% { transform: rotate(0deg); }
  100% { transform: rotate(360deg); }
}
</style>

<!-- ============================================================== -->
<!-- Start right Content here -->
<!-- ============================================================== -->
<div class="content-page">
    <!-- Start content -->
    <div class="content">
        <div class="container">
            <!-- Page-Title -->
            <div class="row">
                <div class="col-sm-10">
                    <h4 class="page-title">Prize Table</h4>
                </div>
                <div class="col-sm-2">
                    <div class="btn-group pull-right">
                        <div hidden class="busy" id="calcBusy"></div>
                        <div class="m-b-30">
                            <button id="btnApply" class="btn btn-default waves-effect waves-light" onclick="onApply();"><i class="fa fa-check-square-o"></i> Apply</button>
                        </div>
                    </div>
                </div>
            </div>

            <?php foreach ($prizes as $prize) {
                $optionId = $prize['option_id']; ?>
                <div class="col-sm-6">
                    <div class="panel panel-color panel-primary">
                        <div class="panel-heading" style="display: flex; justify-content: space-between;">
                            <h3 class="panel-title"><?php echo $prize['option']; ?></h3>
                            <button class="btn btn-sm btn-success" onclick="onCreate('<?php echo $optionId;?>', '<?php echo $prize['option']; ?>');"><i class="fa fa-plus"></i></button>
                        </div>
                        <div class="panel-body">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <th>Range</th>
                                    <th>U3</th>
                                    <th>U4</th>
                                    <th>U5</th>
                                    <th>U6</th>
                                    <th></th>
                                </thead>
                                <tbody>
                                    <?php foreach($prize['ranges'] as $range){ ?>
                                        <tr>
                                            <td><?php echo $range->range_start.' ~ '.$range->range_end;?></td>
                                            <td><?php echo $range->u3;?></td>
                                            <td><?php echo $range->u4;?></td>
                                            <td><?php echo $range->u5;?></td>
                                            <td><?php echo $range->u6;?></td>
                                            <td>
                                                <button class="btn btn-info btn-sm m-r-10"
                                                    onclick="onEdit('<?php echo $optionId;?>', 
                                                    '<?php echo $prize['option']; ?>', 
                                                    <?php echo $range->range_start;?>,
                                                    <?php echo $range->range_end;?>, <?php echo $range->u3;?>,
                                                    <?php echo $range->u4;?>, <?php echo $range->u5;?> , <?php echo $range->u6;?>)">
                                                <i class="fa fa-pencil"></i>
                                                </button>
                                                
                                                <button class="btn btn-danger btn-sm"
                                                    onclick="onDelete('<?php echo $range->Id;?>')">
                                                <i class="fa fa-trash"></i>
                                                </button>
                                                
                                            </td>
                                        </tr>
                                    <?php } ?>
                                </tbody>
                            </table>
                            
                            <form action="<?php echo base_url('/Cms_api/edit_prize_exceptions');?>" method="post">
                                <input hidden name="option" value="<?php echo $optionId; ?>" />
                                <div class="form-group has-success">
                                    <label class="col-md-3 control-label">Exceptions</label>
                                    <div class="col-md-5">
                                        <input class="form-control" type="text" value="<?php echo $prize['exceptions']; ?>" name="exceptions">
                                    </div>
                                    <div class="col-md-4">
                                        <button type="submit" class="btn btn-primary">Save</button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            <?php } ?>
        </div> <!-- container -->
    </div> <!-- content -->


    <!-- dialog -->
    <div id="eidt-modal" class="modal-demo col-sm-12" style="padding: 0px !important;">
        <button type="button" class="close" onclick="Custombox.close();">
            <span>&times;</span><span class="sr-only">Close</span>
        </button>
        <h4 class="custom-modal-title">Edit Prize ( <span id="optionName"></span> )</h4>
        <div class="custom-modal-text text-left">
            <div class="profile-detail card-box">
                <form class="form-horizontal" role="form" style="width:400px;" action="<?php echo base_url('/Cms_api/edit_prize_table'); ?>" method="post">
                    <input type="hidden" id="optionId" name="optionId"/>
                    <input type="hidden" id="isUpdate" name="isUpdate"/>     
                    <div class="form-group has-success">
                        <label class="col-md-3 control-label">Range</label>
                        <div class="col-md-9"  style="display:flex; justify-content: space-between;">
                            <input class="form-control" type="number" id="rangeStart" name="rangeStart" required>
                            <label class="control-label">~</label>
                            <input class="form-control" type="number" id="rangeEnd" name="rangeEnd" required>
                        </div>
                    </div>                    
                    <div class="form-group has-success">
                        <label class="col-md-3 control-label">U3</label>
                        <div class="col-md-9">
                            <input class="form-control" type="number" step="any" id="u3" name="u3" required>
                        </div>
                    </div>
                    <div class="form-group has-success">
                        <label class="col-md-3 control-label">U4</label>
                        <div class="col-md-9">
                            <input class="form-control" type="number" step="any" id="u4" name="u4" required>
                        </div>
                    </div>
                    <div class="form-group has-success">
                        <label class="col-md-3 control-label">U5</label>
                        <div class="col-md-9">
                            <input class="form-control" type="number" step="any" id="u5" name="u5" required>
                        </div>
                    </div>
                    <div class="form-group has-success">
                        <label class="col-md-3 control-label">U6</label>
                        <div class="col-md-9">
                            <input class="form-control" type="number" step="any" id="u6" name="u6" required>
                        </div>
                    </div>
                    <div>
                        <hr>
                        <button type="submit" class="btn btn-pink btn-custom  waves-effect waves-light">Save</button>
                    </div>
                </form>
            </div>
        </div>
    </div>    

    <!-- <script src="<?php echo base_url('assets/plugins/switchery/js/switchery.min.js'); ?>"></script> -->
    <script type="text/javascript">

        function onCreate(optionId, optionName){
            Custombox.open({
                target: "#eidt-modal",
                effect: "fadein",
                overlaySpeed: "200",
                overlayColor: "#36404a"
            });
            $("#optionId").val(optionId);
            $("#optionName").text(optionName);
            $("#isUpdate").val(0);
            $("#rangeStart").prop("readonly", false);
            $("#rangeEnd").prop("readonly", false);
        }

        function onEdit(optionId, optionName, rangeStart, rangeEnd, u3, u4, u5, u6){
            Custombox.open({
                target: "#eidt-modal",
                effect: "fadein",
                overlaySpeed: "200",
                overlayColor: "#36404a"
            });

            $("#optionId").val(optionId);
            $("#optionName").text(optionName);
            $("#rangeStart").val(rangeStart);
            $("#rangeEnd").val(rangeEnd);
            $("#isUpdate").val(1);
            $("#rangeStart").prop("readonly", true);
            $("#rangeEnd").prop("readonly", true);

            $("#u3").val(u3);
            $("#u4").val(u4);
            $("#u5").val(u5);
            $("#u6").val(u6);
        }



        function onDelete(rangeId){
            $.ajax({
                url: "<?php echo site_url('Cms_api/delete_prize_table') ?>",
                data: {
                    rangeId: rangeId
                },
                type: "POST",
                dataType: "JSON",
                success: function(data) {
                    window.location = "<?php echo base_url('Cms/prize_table'); ?>";
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    swal("Error!", "", "error");
                }
            });
        }


        function onApply()
        {
            document.getElementById("calcBusy").style.display = "block";
            document.getElementById("btnApply").style.display = "none";
            
            $.ajax({
                url: "<?php echo site_url('Api/apply_game_result') ?>",
                data: {
                },
                type: "POST",
                dataType: "JSON",
                success: function(data) {
                    document.getElementById("calcBusy").style.display = "none";
                    document.getElementById("btnApply").style.display = "block";
                    
                    if(data.status==200)
                    {
                        swal("Apply Success!", "", "success");
                    }
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    document.getElementById("calcBusy").style.display = "none";
                    document.getElementById("btnApply").style.display = "block";
                    
                    swal("Error!", "", "error");
                }
            });
        }
    </script>